var gFindBar = {

  SELECTION_CONTROLLER: Components.interfaces.nsISelectionController,

  FIND_NORMAL : 0,
  FIND_TYPEAHEAD : 1,
  FIND_LINKS : 2,

  FIND_FOUND : 0,
  FIND_NOTFOUND : 1,
  FIND_WRAPPED: 3,

  mFindEnabled: true,

  mWrappedToTopStr: "",
  mWrappedToBottomStr: "",
  mNotFoundStr: "",
  mCaseSensitiveStr: "",
  mNormalFindStr: "",
  mFastFindStr: "",
  mCaseSensitiveStr: "",

  mInitialized: false,

  mFindService = Components.classes["@mozilla.org/find/find_service;1"]
                 .getService(Components.interfaces.nsIFindService),
  gFindInstData: null,
  gFindInst: null,

  mFindToolbar: null,
  mFindLabel: null,
  mFindField: null,
  mFindNext: null,
  mFindPrev: null,
  mFindWrap: null,
  mHighlight: null,
  mMatchCaseCheckbox: null,
  mMatchCaseText: null,
  mStatusIcon: null,
  mStatusText: null,

  initFindbar: function () {
    this.getFindInstData();

  	if (this.mInitialized) {
      return;
  	}
    this.mFindToolbar = document.getElementById("FindToolbar");
    this.mFindLabel = document.getElementById("find-label");
    this.mFindField = document.getElementById("find-field");
    this.mFindNext = document.getElementById("find-next");
    this.mFindPrev = document.getElementById("find-previous");
    this.mFindWrap = document.getElementById("find-wrapped");
    this.mHighlight = document.getElementById("highlight");

    this.mMatchCaseCheckbox = document.getElementById("find-case-sensitive");
    this.mMatchCaseText = document.getElementById("match-case-status");
    this.mStatusIcon = document.getElementById("find-status-icon");
    this.mStatusText = document.getElementById("find-status");

    var bundle = document.getElementById("bundle_findBar");
    this.mNotFoundStr = bundle.getString("NotFound");
    this.mWrappedToTopStr = bundle.getString("WrappedToTop");
    this.mWrappedToBottomStr = bundle.getString("WrappedToBottom");
    this.mNormalFindStr = bundle.getString("NormalFindLabel");
    this.mFastFindStr = bundle.getString("FastFindLabel");
    this.mCaseSensitiveStr = bundle.getString("CaseSensitive");

    this.mFindLabel.value = this.mNormalFindStr;


    this.mInitialized = true;
  }

  getFindInstData: function () {
    if (!this.gFindInstData) {
      this.gFindInstData = new nsFindInstData();
      this.gFindInstData.browser = getBrowser();
      // defaults for rootSearchWindow and currentSearchWindow are fine here
      this.findInstData.init();
      this.gFindInst = this.gFindInstData.webBrowserFind;
    }
    return this.gFindInstData;
  },

 /**
  * Turns highlighting on or off.
  *
  * @param aHighlight true to turn highlighting on
  */
  toggleHighlight: function (aHighlight)
  {
    var word = document.getElementById("find-field").value;
    if (aHighlight) {
      // We have to update the status because we might still have the status
      // of another tab
      if (this.highlightDoc('yellow', 'black', word))
        this.updateStatus(this.FIND_FOUND, false);
      else
        this.updateStatus(this.FIND_NOTFOUND, false);
    } else {
      this.highlightDoc(null, null, null);
      this.mLastHighlightString = null;
    }
  },

  /**
   * Opens and displays the find bar.
   *
   * @param   showMinimalUI
   *          true if the find bar is to contain minimalist UI, false (or
   *          undefined, as happens if no arguments are provided) if the find
   *          bar is to display more generalized search UI
   * @returns bool
   *          true if the find bar wasn't previously open, false otherwise
   */
  openFindBar: function (showMinimalUI)
  {
    this.initFindbar();

    // Notify anyone else that might want to handle this event
    var findActivatedEvent = document.createEvent("Events");
    findActivatedEvent.initEvent("find-activated", false, true);
    window.dispatchEvent(findActivatedEvent);
    if (!this.mFindEnabled)
      throw Components.results.NS_OK;
 
    if (this.mFindToolbar.hidden) {
      this.mFindToolbar.hidden = false;
      this.mFindField.value = this.gFindInst.searchString ?
                        this.gFindInst.searchString : this.mFindService.searchString;
      // this.setCaseSensitivity(this.mFindField.value);
      this.mFindWrap.checked = this.gFindInst.wrapFind ?
        this.gFindInst.wrapFind : this.mFindService.wrapFind;
      this.mMatchCaseCheckbox.checked = this.gFindInst.matchCase ?
        this.gFindInst.matchCase : this.mFindService.matchCase;
      this.enableFindButtons(this.mFindField.value);
      this.updateStatus(this.FIND_FOUND, false);

      return true;
    }
    return false;
  },

  focusFindBar: function ()
  {
    var findField = document.getElementById("find-field");
    findField.focus();    
  },

  selectFindBar: function ()
  {
    var findField = document.getElementById("find-field");
    findField.select();    
  },

  closeFindBar: function ()
  {
    // ensure the dom is ready...
    setTimeout(findBar_DelayedCloseFindBar, 0);
  },

  fireKeypressEvent: function (target, evt)
  {
  },

  updateStatusBar: function ()
  {
  },

  setFoundLink: function (foundLink)
  {
  },

  delayedCloseFindBar: function ()
  {
  },

  shouldBeCaseSensitive: function (str)
  {
  },

  onFindBarBlur: function ()
  {
  },

  onBrowserMouseUp: function (evt)
  {
  },

  onBrowserKeyPress: function (evt)
  {
  },

  onFindBarKeyPress: function (evt)
  {
    if (evt.keyCode == KeyEvent.DOM_VK_RETURN) {
        var findString = document.getElementById("find-field");
        if (!findString.value)
          return;

        if (evt.ctrlKey) {
          document.getElementById("highlight").click();
          return;
        }

        if (evt.shiftKey)
          this.findPrevious();
        else
          this.findNext();
    }
    else if (evt.keyCode == KeyEvent.DOM_VK_TAB) {
      var shouldHandle = !evt.altKey && !evt.ctrlKey && !evt.metaKey;
      if (shouldHandle && this.mFindMode != this.FIND_NORMAL &&
          this.finishFAYT(evt)) {
        if (evt.shiftKey)
          document.commandDispatcher.rewindFocus();
        else
          document.commandDispatcher.advanceFocus();
      }
    }
    else if (evt.keyCode == KeyEvent.DOM_VK_ESCAPE) {
      this.closeFindBar();
      evt.preventDefault();
    } 
    else if (evt.keyCode == KeyEvent.DOM_VK_PAGE_UP) {
      window.top._content.scrollByPages(-1);
      evt.preventDefault();
    }
    else if (evt.keyCode == KeyEvent.DOM_VK_PAGE_DOWN) {
      window.top._content.scrollByPages(1);
      evt.preventDefault();
    }
    else if (evt.keyCode == KeyEvent.DOM_VK_UP) {
      window.top._content.scrollByLines(-1);
      evt.preventDefault();
    }
    else if (evt.keyCode == KeyEvent.DOM_VK_DOWN) {
      window.top._content.scrollByLines(1);
      evt.preventDefault();
    }
  },

  enableFindButtons: function (aEnable)
  {
    var findNext = document.getElementById("find-next");
    var findPrev = document.getElementById("find-previous");
    var highlight = document.getElementById("highlight");
    this.mFindNext.disabled =
    this.mFindPrev.disabled =
    this.mFindWrap.disabled =
    this.mHighlight.disabled = !aEnable;
  },

  /**
   * Determines whether minimalist or general-purpose search UI is to be
   * displayed when the find bar is activated.
   *
   * @param showMinimalUI
   *        true if minimalist UI should be used, false if general-purpose UI
   *        should be used
   */
  updateFindUI: function (showMinimalUI)
  {
  },

  find: function (val)
  {
  },

  flashFindBar: function ()
  {
    var findToolbar = document.getElementById("FindToolbar");
    if (this.mFlashFindBarCount-- == 0) {
      clearInterval(this.mFlashFindBarTimeout);
      findToolbar.removeAttribute("flash");
      this.mFlashFindBarCount = 6;
      return;
    }
   
    findToolbar.setAttribute("flash",
                             (this.mFlashFindBarCount % 2 == 0) ?
                             "false" : "true");
  },

  onFindCmd: function ()
  {
  },

  onFindAgainCmd: function ()
  {
  },

  onFindPreviousCmd: function ()
  {
  },

  setHighlightTimeout: function ()
  {
    if (this.mHighlightTimeout)
      clearTimeout(this.mHighlightTimeout);
    this.mHighlightTimeout =
      setTimeout(function() {
                   gFindBar.toggleHighlight(false);
                   gFindBar.toggleHighlight(true);
                 }, 500);  
  },

  isFindBarVisible: function ()
  {
    var findBar = document.getElementById("FindToolbar");
    return !findBar.hidden;
  },

  findNext: function ()
  {
  },

  findPrevious: function ()
  {
  },

  updateStatus: function (res, findNext)
  {
    switch(res) {
      case this.FIND_WRAPPED:
        this.mStatusIcon.setAttribute("status", "wrapped");      
        this.mStatusText.value =
          findNext ? this.mWrappedToTopStr : this.mWrappedToBottomStr;
        break;
      case this.FIND_NOTFOUND:
        this.mStatusIcon.setAttribute("status", "notfound");
        this.mStatusText.value = this.mNotFoundStr;
        this.mFindField.setAttribute("status", "notfound");      
        break;
      case this.FIND_FOUND:
      default:
        this.mStatusIcon.removeAttribute("status");      
        this.mStatusText.value = "";
        this.mFindField.removeAttribute("status");
        break;
    }
  },

  setFindCloseTimeout: function ()
  {
  },

  findBarOnDrop: function (evt)
  {
    nsDragAndDrop.drop(evt, this.mFindbarObserver);
  },

  onFindBarCompositionStart: function (evt)
  {
  },

  onFindBarCompositionEnd: function (evt)
  {
  },

  setFindMode: function (mode)
  {
    this.mFindMode = mode;
  }

 /**
  * (Un)highlights each instance of the searched word in the passed window's content.
  *
  * @param highBackColor the background color for the highlight 
  * @param highTextColor the text color for the highlight, or null to make it unhighlight
  * @param word the word to search for
  * @param win the window to search in. Passing undefined will search the current window.
  * @return true if the text was found
  */
  highlightDoc: function (highBackColor, highTextColor, word, win)
  {
    if (!win)
      win = window.content; 

    var textFound = false;
    for (var i = 0; win.frames && i < win.frames.length; i++) {
      if (this.highlightDoc(highBackColor, highTextColor, word, win.frames[i]))
        textFound = true;
    }

    var doc = win.document;
    if (!doc || !("body" in doc))
      return textFound;

    var body = doc.body;

    var count = body.childNodes.length;
    this.mSearchRange = doc.createRange();
    this.mStartPt = doc.createRange();
    this.mEndPt = doc.createRange();

    this.mSearchRange.setStart(body, 0);
    this.mSearchRange.setEnd(body, count);

    this.mStartPt.setStart(body, 0);
    this.mStartPt.setEnd(body, 0);
    this.mEndPt.setStart(body, count);
    this.mEndPt.setEnd(body, count);

    if (!highBackColor) {
      // Remove highlighting.  We use the find API again rather than
      // searching for our span elements by id so that we gain access to the
      // anonymous content that nsIFind searches.

      if (!this.mLastHighlightString)
        return textFound;

      var retRange = null;
      var finder = Components.classes["@mozilla.org/embedcomp/rangefind;1"]
                             .createInstance()
                             .QueryInterface(Components.interfaces.nsIFind);

      while ((retRange = finder.Find(this.mLastHighlightString,
                                     this.mSearchRange, this.mStartPt,
                                     this.mEndPt))) {
        var startContainer = retRange.startContainer;
        var elem = null;
        try {
          elem = startContainer.parentNode;
        }
        catch (e) { }

        if (elem && elem.getAttribute("id") == "__firefox-findbar-search-id") {
          var child = null;
          var docfrag = doc.createDocumentFragment();
          var next = elem.nextSibling;
          var parent = elem.parentNode;

          while ((child = elem.firstChild)) {
            docfrag.appendChild(child);
          }

          this.mStartPt = doc.createRange();
          this.mStartPt.setStartAfter(elem);

          parent.removeChild(elem);
          parent.insertBefore(docfrag, next);
          parent.normalize();
        }
        else {
          // Somehow we didn't highlight this instance; just skip it.
          this.mStartPt = doc.createRange();
          this.mStartPt.setStart(retRange.endContainer, retRange.endOffset);
        }

        this.mStartPt.collapse(true);

        textFound = true;
      }
      return textFound;
    }

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + highBackColor + "; " +
                                   "color: " + highTextColor + "; " +
                                   "display: inline; font-size: inherit;" +
                                   " padding: 0;");
    baseNode.setAttribute("id", "__firefox-findbar-search-id");

    return this.highlightText(word, baseNode) || textFound;
  },

 /**
  * Highlights each instance of the searched word in the current range.
  *
  * @param word the word to search for
  * @param baseNode a node to use as a template for what will replace the
  *                 searched word
  * @return true if the text was found
  */
  highlightText: function (word, baseNode)
  {
    var retRange = null;
    var finder = Components.classes["@mozilla.org/embedcomp/rangefind;1"]
                           .createInstance()
                           .QueryInterface(Components.interfaces.nsIFind);

    finder.caseSensitive = this.shouldBeCaseSensitive(word);

    var textFound = false;
    while((retRange = finder.Find(word, this.mSearchRange,
                                  this.mStartPt, this.mEndPt))) {
      // Highlight
      var nodeSurround = baseNode.cloneNode(true);
      var node = this.highlight(retRange, nodeSurround);
      this.mStartPt = node.ownerDocument.createRange();
      this.mStartPt.setStart(node, node.childNodes.length);
      this.mStartPt.setEnd(node, node.childNodes.length);

      textFound = true;
    }

    this.mLastHighlightString = word;

    return textFound;
  },

 /**
  * Highlights the word in the passed range.
  *
  * @param range the range that contains the word to highlight
  * @param node the node replace the searched word with
  * @return the node that replaced the searched word
  */
  highlight: function (range, node)
  {
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;
    var endOffset = range.endOffset;
    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
  },

  setCaseSensitivity: function (val)
  {
  },

  toggleCaseSensitiveCheckbox: function (aCaseSensitive)
  {
  },
};

// ================
//  Event Handlers
// ================
function findBar_OnDrop(aEvt)
{
  gFindBar.findBarOnDrop(aEvt);
}

function findBar_OnBrowserKeyPress(aEvt)
{
  gFindBar.onBrowserKeyPress(aEvt);
}

function findBar_OnBrowserMouseUp(aEvt)
{
  gFindBar.onBrowserMouseUp(aEvt);
}

// ======================
//  Timer Event Handlers
// ======================
function findBar_DelayedCloseFindBar()
{
  gFindBar.delayedCloseFindBar();
}

function findBar_UpdateStatusBar()
{
  gFindBar.updateStatusBar();
}

function findBar_FlashFindBar()
{
  gFindBar.flashFindBar();
}
